/*
Copyright (c) 2003-2004, Gregory Kuhlmann, Peter Stone, Justin Lallinger,
University of Texas at Austin
All right reserved

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

3. Neither the name of the University of Texas nor the names of its
contributors may be used to endorse or promote products derived from this
software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _STOCK_ACTION_
#define _STOCK_ACTION_
#include "ClangDirective.h"

// These represent the "stock actions" that a player
// always considers in addition to any given coach advice


#define STOCK_PASS 		-1
#define STOCK_SHOOT		-2
#define STOCK_INTERCEPT		-3
#define STOCK_GO_HOME		-4
#define STOCK_GO_POS		-10
#define STOCK_CLEAR_LEFT	-5
#define STOCK_CLEAR_RIGHT	-6
#define STOCK_CLEAR_CENTER	-12
#define STOCK_DRIBBLE_LEFT	-7
#define STOCK_DRIBBLE_RIGHT	-8
#define STOCK_DRIBBLE_CENTER	-13
#define STOCK_GOALIE_CATCH	-9
#define STOCK_HOLD		-11
#define STOCK_RECEIVE_PASS      -14
#define STOCK_MARK		-15


#define STOCK_CLEAR_LEFT_X	52.5
#define STOCK_CLEAR_LEFT_Y	-34

#define STOCK_CLEAR_RIGHT_X	52.5
#define STOCK_CLEAR_RIGHT_Y	34


#define STOCK_DRIBBLE_LEFT_X	52.5
#define STOCK_DRIBBLE_LEFT_Y	-34

#define STOCK_DRIBBLE_RIGHT_X	52.5
#define STOCK_DRIBBLE_RIGHT_Y	34


class StockAction: public Action
{
public:
  StockAction( ActType t, int i = 0 ) {
    type = t;
    iarg = i;
  }
  virtual ~StockAction() {}
  virtual ActType GetType()
  {
    return type;
  }
  virtual void Output( ostream & os, bool dv = true );
  virtual int GetIntArg()
  {
    return iarg;
  }

private:
  int iarg;
  ActType type;

} ;

#endif
